#~~syntax:makefile

CC       := gcc
CXX      := g++
CFLAGS   := -D_LARGEFILE_SOURCE -D_LARGE_FILES -D_FILE_OFFSET_BITS=64 \
            -D_REENTRANT -DPIC -Wall -Waggregate-return \
            -Wmissing-declarations -Wmissing-prototypes -Wredundant-decls \
            -Wshadow -Wstrict-prototypes -Winline -fPIC -pipe
CXXFLAGS := -D_LARGEFILE_SOURCE -D_LARGE_FILES -D_FILE_OFFSET_BITS=64 \
            -D_REENTRANT -DPIC -Wall -Wmissing-prototypes \
            -Wredundant-decls -Wstrict-prototypes -fPIC -pipe
AS       := gcc # as
ASFLAGS  :=
LD       := gcc # ld
LDXX     := g++ # ld
LDFLAGS  := 
SOFLAGS  := -shared
AR       := ar
ARFLAGS  :=

CP       := cp
LN       := ln
TOUCH    := touch

ifeq (${DEBUG},1)
  CFLAGS   += -ggdb3
  CXXFLAGS += -ggdb3
  ASFLAGS  += -ggdb3
  STRIP    := @true
else
  CFLAGS   += -O2 -finline-functions -fomit-frame-pointer
  CXXFLAGS += -O2 -finline-functions -fomit-frame-pointer
  ASFLAGS  += -O2 -finline-functions -fomit-frame-pointer
  STRIP    := strip -s
endif
ifeq (${PROF},1)
  CFLAGS   += -pg -fprofile-arcs -ftest-coverage
  CXXFLAGS += -pg -fprofile-arcs -ftest-coverage
  LDFLAGS  += -pg -fprofile-arcs -ftest-coverage
  ASFLAGS  += -pg -fprofile-arcs -ftest-coverage
  STRIP    := true
endif

ifeq (${V},)
  CC   := @${CC}
  CXX  := @${CXX}
  AS   := @${AS}
  LD   := @${LD}
  LDXX := @${LDXX}
  AR   := @${AR}

  CP    := @${CP}
  LN    := @${LN}
  STRIP := @${STRIP}
  TOUCH := @${TOUCH}

  VECHO_DEP = @echo "  DEP   " $@
  VECHO_CC  = @echo "  CC    " $@
  VECHO_AS  = @echo "  AS    " $@
  VECHO_LD  = @echo "  LD    " $@
  VECHO_AR  = @echo "  AR    " $@
endif

#==============================================================================
